/* freadf.c -- Copyright 1992 Liam R. E. Quin.  All Rights Reserved.
 * This code is NOT in the public domain.
 * See the file COPYRIGHT for full details.
 */

/* $Id: freadf.c,v 1.1 93/09/06 12:42:47 lee Exp $
 * read files into memory.
 */

#include <stdio.h>
#include <ctype.h>

#include "globals.h"
#include "emalloc.h"

extern int AsciiTrace;

#include <stdio.h>
#include <ctype.h>	/* isspace() etc */
#include <malloc.h>	/* This declares malloc(), realloc() etc... */

#include "globals.h"
#include "error.h"
#include "emalloc.h"

#include "readfile.h"

long
fReadFile(Severity, f, Name, What, Lines, Flags)
    int Severity;	/* to pass to Error() if necessary */
    FILE *f;
    char *Name;		/* the filename to read */
    char *What;
    char ***Lines;
    int Flags;
{
    /* This is where the real work is done... */

    long NumberOfLines = 0L;
    long LinesAllocated = 0L;
    char *Linep;

    LinesAllocated = 20;
    *Lines = (char **) malloc(sizeof(char *) * LinesAllocated);

    while (fReadLine(f, &Linep, Flags) >= 0) {
	if (NumberOfLines >= LinesAllocated) {
	    LinesAllocated += 50;
	    *Lines = (char **) realloc((char *) *Lines,
				(unsigned) (LinesAllocated * sizeof(char *)));
	    if (!*Lines) {
		Error(Severity|E_MEMORY, "Lines from \"%s\" (%s)", Name, What);
		return -1;
	    }
	}

	(*Lines)[NumberOfLines] = Linep;
	++NumberOfLines;
    }

    return NumberOfLines;
}

